<template lang="pug">
form.form( @submit.prevent='submit' )
	.field
		label.label.is-large.mb-4 {{$t("form.data")}}
	.field.is-grouped
		label.label.on-border
			span {{$t("form.brand")}}&nbsp;
			span.has-text-danger *
		brand-selector( v-model='data.brand' )
		.control.is-flex-grow-0.is-flex.is-align-items-center
			b-checkbox( v-model='data.car.active' ) {{$t("form.active")}}

	template( v-if='data.brand && Object.keys(data.brand).length' )
		name-slug( v-model='data.car' type="car" :brand='data.brand' )
		.field.is-grouped.mt-5
			label.label.on-border
				span {{$t("form.year")}}&nbsp;
				span.has-text-danger *
			.control.is-expanded
				b-input( v-model='data.car.year' input-type="number" )
			.control
				.field.has-addons
					.control
						span.button.is-static $
					label.label.on-border {{$t("form.deposit")}}
					.control
						b-input( v-model='data.car.deposit' input-type="number" )
			.control
				.field.has-addons
					.control
						span.button.is-static $
					label.label.on-border {{$t("form.price")}}
					.control
						b-input( v-model='data.car.price' input-type="number" )
			.control
				.field.has-addons
					.control
						input.input( v-model='data.car.stock' )
					label.label.on-border {{$t("form.percent")}}
					.control
						span.button.is-static %
		hr
		.tile.is-ancestor
			.tile.is-parent.is-6
				car-options.tile.is-child( v-model='data.options' )
			.tile.is-parent.is-6
				car-images.tile.is-child( v-model='data.images' )
		hr
		.field.is-marginless
			label.label.is-large.mb-4 {{$t("form.content_on_car_page")}}
		.tile.is-ancestor
			.tile.is-parent.is-6
				.tile.is-child
					b-content( v-model='data.content.ru' ) RU
			.tile.is-parent.is-6
				.tile.is-child
					b-content( v-model='data.content.en' ) EN
		hr
		meta-form( v-model='data.meta' )
		hr
		.field
			.control
				b-button( node="button" type="primary" :loading='pending' fullwidth ) {{ edit ? $t("buttons.change") : $t("buttons.create") }}
</template>

<script setup>
	import NameSlug from "@/components/NameSlug.vue"
	import MetaForm from "@/components/meta/Form.vue"
	import BrandSelector from "@/components/brand/Selector.vue"
	import CarOptions from "@/components/car/Options.vue"
	import CarImages from "@/components/car/Images.vue"
	import BInput from "@/components/form/Input.vue"
	import BCheckbox from "@/components/form/Checkbox.vue"
	import BContent from "@/components/form/Content.vue"

	import slugify from "@/common/slugify"
	import { useCarStore } from "@/stores/car"
	import { computed, ref, watch } from "vue"
	import { useToast } from "vue-toastification"
	import { useI18n } from "vue-i18n"

	const { t } = useI18n()
	const toast = useToast()
	const cs = useCarStore()
	const props = defineProps({
		defaults: Object,
		edit: Boolean
	})
	const emit = defineEmits([ "submit" ])

	const defaults = computed(() => props.defaults)
	const data = ref(defaults.value || {
		brand: null,
		car: { active: true },
		meta: null,
		options: null,
		images: null,
		content: {
			ru: { data: null },
			en: { data: null }
		}
	})
	watch(() => ({ ...defaults.value }), () => data.value = defaults.value)

	const pending = computed(() => cs.pending)

	watch(() => data.value.car?.year, nv => {
		if (data.value.car?.slug) {
			if (nv)
				data.value.car.slug = slugify(`${data.value.car?.name}-${nv}`)
			else
				data.value.car.slug = slugify(`${data.value.car?.name}`)
		}
	})

	const submit = () => {
		if (pending.value) return

		if (!data.value.car.name || !data.value.car.slug || !data.value.car.year)
			return toast.warning(t("default.required_fields_incorrenct"))

		emit("submit", data.value)
	}
</script>

<style lang="scss" scoped>
	.control {
		:deep(.input) {
			position: relative;
			z-index: 1!important;
		}
	}
</style>